<?php

class status_model extends CI_Model {

	function __construct()
	{
		// Call the Model constructor
		parent::__construct();
	}


	// FIXME: this method needs cleanup
	// Get current system status for JSON
	function get_current_status()
	{
		$this->load->model('data_file_model');
		$obj = new StdClass;

		// PROVE mode - Use undocumented API. -1 get mode from file.
		$mode = prove_mode(-1);
		switch($mode) {
		case PROVE_MODE_TRACE:
			$obj->mode = PROVE_MODE_TRACE;
			$obj->mode_str = '<span style="color:red">トレースモード</span>';
			$obj->mode_img = base_url('img/trace-mode.png');
			break;
		case PROVE_MODE_VALIDATE:
			$obj->mode = PROVE_MODE_VALIDATE;
			$obj->mode_str = '<span style="color:blue">バリデーション</span>';
			$obj->mode_img = base_url('img/validate-mode.png');
			break;
		default:
		case PROVE_MODE_DISABLED:
			$obj->mode = PROVE_MODE_DISABLED;
			$obj->mode_str = 'PROVE無効';
			$obj->mode_img = base_url('img/disable-mode.png');
			break;
		}
		
		// Validation mode status
		$obj->client_status   = $this->get_client_status();
		// prove_client output
		$obj->client_log       = $this->get_client_log();
		$obj->trace_meta       = $this->data_file_model->get_trace_meta();
		$obj->validate_meta    = $this->data_file_model->get_validate_meta();
		$obj->diff_meta        = $this->data_file_model->get_diff_meta();
		// Trace/Validate/Diff data counts
		$obj->trace_records    = $this->data_file_model->count_trace_records();
		$obj->validate_records = $this->data_file_model->count_validate_records();
		$obj->diff_records     = $this->data_file_model->count_diff_records();
		// Log ID
		$obj->trace_log_id     = prove_log_id(PROVE_LOG_TRACE);
		$obj->validate_log_id  = prove_log_id(PROVE_LOG_VALIDATE);
		$obj->diff_log_id      = prove_log_id(PROVE_LOG_DIFF);

		return $obj;
	}


	// FIXME: This method needs cleanup
	// Check system for HTML output
	function check_system()
	{
		$this->load->model('data_file_model');
		$this->load->model('config_model');

		$ret['errors'] = array();
		if (empty($_SERVER['PHP_AUTH_USER'])) {
			$ret['errors'][] = '【重要】HTTP認証が無効です。PROVE管理ツールが管理者以外からアクセスできる場合、セキュリティ問題となります。';
		}

		if (empty($_COOKIE[prove_magic_cookie()])) {
			// Set magic cookie
			setcookie(prove_magic_cookie(),1, time()+86400*1000);
			$ret['errors'][] = 'MAGIC Cookieを設定しました。次のリクエストからこのブラウザからのリクエストは無視されます。';
		}

		if (!extension_loaded('prove')) {
			$ret['errors'][] = 'PROVEがロードされていません。';
			return $ret;
		}

		if (version_compare(prove_version(), PROVE_VERSION, '<')) {
			$ret['errors'][] = 'PROVE '.PROVE_VERSION.'以上を必要としています。このPROVEは'.prove_version().'です。';
			return $ret;
		}

		preg_match('/^(\d)\.(\d)/', prove_version(), $m1);
		preg_match('/^(\d)\.(\d)/', PROVE_VERSION, $m2);
		if ($m1[1] !== $m2[1]) {
			$ret['errors'][] = 'PROVE '.PROVE_VERSION.'は'.prove_version().'と互換性がありません。バージョンアップをしてください。';
			if ($m1[2] !== $m2[2]) {
				$ret['errors'][] = 'PROVE '.PROVE_VERSION.'は'.prove_version().'とマイナーバージョンが異なります。正常に動作しない場合があります。バージョンアップをしてください。';
			}
			return $ret;
		}


		// This may fail?
		$info = @prove_info();
		$ret['prove_info'] = $info;

		// Need to fetch mode from mode file.
		// Validation mode is disabled without HTTP_X_PROVE_ID header.
		// Trace mode is disabled with magic cookie.
		$mode = prove_mode(-1);

		$ret['errors']			= array_merge($ret['errors'], $this->config_model->check_env());
		$ret['fs_type']			= $this->data_file_model->fs_type();

		$ret['trace_record']	= $this->data_file_model->count_trace_records();
		$ret['validate_record'] = $this->data_file_model->count_validate_records();
		$ret['diff_record']		= $this->data_file_model->count_diff_records();

		$prove_dir = ini_get('prove.prove_dir');
		$ret['trace_dir']		= $prove_dir.(substr($prove_dir, -1, 1) == DS ? '' : DS).PROVE_TRACE_PATH;
		$ret['validate_dir']	= $prove_dir.(substr($prove_dir, -1, 1) == DS ? '' : DS).PROVE_VALIDATE_PATH;
		$ret['diff_dir']		= $prove_dir.(substr($prove_dir, -1, 1) == DS ? '' : DS).PROVE_DIFF_PATH;

		$this->load->helper('number');
		$ret['prove_free']		= @byte_format(disk_free_space($ret['prove_info']['prove_dir']));
		$ret['prove_total']		= @byte_format(disk_total_space($ret['prove_info']['prove_dir']));

		$ret['prove_dir']		= $this->data_file_model->list_prove_dir();

		// Get prove new and cache it
		$cache_file = '/tmp/prove_news.txt';
		if (!@stat($cache_file) || time() - file_mtime($cache_file) > 7200) {
			$ret['prove_news'] = @file_get_contents('http://www.provephp.com/ja/news.txt');
		} else {
			$ret['prove_news'] = @file_get_contents($cache_file);
		}

		return $ret;
	}


	// Get client status. Executing or not.
	function get_client_status()
	{
		$this->load->model('validate_model');
		return $this->validate_model->get_status();
	}


	// Get client output log.
	function get_client_log($lines = 200)
	{
		$this->load->model('validate_model');
		return $this->validate_model->get_log($lines);
	}
}
