<?php
class validate_model extends CI_Model {

	function __construct()
	{
		// Call the Model constructor
		parent::__construct();
	}


	function get_status() {
		$this->load->model('config_model');
		$this->load->model('status_model');
		$this->load->model('data_file_model');

		// messages
		$no_data      = 'データが在りません';
		$locked       = 'トレースログまたは差分ログがロックされています。';
		$ok           = '<span style="color:blue">実行可能</span>';
		$executing    = '<span style="color:red">実行中</span>';

		$config = $this->config_model->get();
		$pid_file = $config['prove_client.pid'];

		$recs = $this->data_file_model->count_validate_records();
		if ($recs <= 0) {
			return $no_data;
		}

		/*
		// Check trace/diff log lock
		$meta = prove_log_meta(prove_log_id(PROVE_LOG_TRACE));
		if ($meta && $meta['locked']) {
			return $locked;
		}
		$meta = prove_log_meta(prove_log_id(PROVE_LOG_DIFF));
		if ($meta && $meta['locked']) {
			return $locked;
		}
		*/

		// check pid
		$pid = (int)@file_get_contents($pid_file);
		if (!$pid) {
			return $ok;
		}
		//FIXME make this portable
		if (!@stat('/proc/'.$pid.'/cmdline')) {
			return $ok;
		}
		$cmd = 'LANG=C LC_ALL=C cat /proc/'.$pid.'/cmdline';
		$cmdline = shell_exec($cmd);
		if (strpos($cmdline, 'prove_client') !== FALSE) {
			return $executing;
		}
		return $ok;
	}


	function get_log($lines)
	{
		$this->load->model('config_model');
		$config = $this->config_model->config;

		// get last $lines log
		$fp = @fopen($config['prove_client.out'], 'r');
		if (!$fp) {
			return NULL;
		}
		fseek($fp, -512*$lines, SEEK_END);
		$log = fread($fp, 512*$lines);
		$offset = 0;
		for ($i=0; $i<$lines; $i++) {
			$last_nl = strrpos($log, PHP_EOL, $offset);
			$log     = substr($log, 0, $last_nl);
			$offset  = strrpos($log, PHP_EOL);
			$ret[]   = substr($log, $offset+1, strlen($log) - $offset);
			if (!$offset) {
				break;
			}
		}
		return join(array_reverse($ret), PHP_EOL);
	}


	function start()
	{
		$this->load->model('config_model');
		$config = $this->config_model->config;

		// Check $config['prove_client.out'] is writable.
		if (!@touch($config['prove_client.out'])) {
			return 'ERROR: Prove client ('.$config['prove_client.out'].') cannot be written.';
		}
		// Check pid file
		if (!@touch($config['prove_client.pid'])) {
			return 'ERROR: Prove client ('.$config['prove_client.pid'].') cannot be written.';
		}
		// Check $config['prove_client'] is readable
		if (!@is_readable($config['prove_client'])) {
			exec('echo "  Prove client ('.$config['prove_client'].')  " >> '.$config['prove_client.out']);
			return 'ERROR: Prove client ('.$config['prove_client'].') cannot be read.';
		}

		// Trace data must be unlocked. Unlock may block request
		$this->load->model('lock_model');
		$this->lock_model->unlock_trace_log();
		$this->lock_model->unlock_diff_log();

		// Try to stop running validation
		$this->stop();

		$opts = '-d prove.mode_file=/tmp/prove_client_mode -d display_errors=off -d memory_limit=3072M';
		$cmd = 'LANG=C LC_ALL=C '.$config['php.exe'].' -c '.$config['php.ini'].' '.$opts.' '.$config['prove_client'].' > '. $config['prove_client.out'].' 2>&1 &';
		error_log('[PROVE] >>>'.$cmd.'<<< executed.');
		exec($cmd, $out, $ret);
		sleep(1);
		return 'exit status: '.$ret. ' cmd: '.$cmd;
	}


	function stop()
	{
		$this->load->model('config_model');
		$config = $this->config_model->config;
		
		if (@stat($config['prove_client.pid'])) {
			// try to kill the pid
			$pid = (int)file_get_contents($config['prove_client.pid']);
			if (@stat('/proc/'.$pid.'/cmdline')) {
				error_log('[PROVE] killed pid='.$pid.' ');
				exec('kill -KILL '.$pid);
			}
			unlink($config['prove_client.pid']);
			// Write message to log
			exec('echo "  Stopped!	" >> '.$config['prove_client.out']);
			return 'killed '.$pid;
		} else {
			return 'cannot find pid file ('. $config['prove_client.pid']. ')';
		}
	}
}